/*
 * generated by Xtext 2.27.0
 */
package org.eclipse.papyrus.robotics.assertions.languages.stl.serializer;

import com.google.inject.Inject;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.papyrus.robotics.assertions.languages.stl.services.STLGrammarAccess;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AlternativeAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public class STLSyntacticSequencer extends AbstractSyntacticSequencer {

	protected STLGrammarAccess grammarAccess;
	protected AbstractElementAlias match_intervalTime_UNITTerminalRuleCall_0_1_q;
	protected AbstractElementAlias match_intervalTime_UNITTerminalRuleCall_1_1_q;
	protected AbstractElementAlias match_interval_COLONTerminalRuleCall_2_0_or_COMMATerminalRuleCall_2_1;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (STLGrammarAccess) access;
		match_intervalTime_UNITTerminalRuleCall_0_1_q = new TokenAlias(false, true, grammarAccess.getIntervalTimeAccess().getUNITTerminalRuleCall_0_1());
		match_intervalTime_UNITTerminalRuleCall_1_1_q = new TokenAlias(false, true, grammarAccess.getIntervalTimeAccess().getUNITTerminalRuleCall_1_1());
		match_interval_COLONTerminalRuleCall_2_0_or_COMMATerminalRuleCall_2_1 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getIntervalAccess().getCOLONTerminalRuleCall_2_0()), new TokenAlias(false, false, grammarAccess.getIntervalAccess().getCOMMATerminalRuleCall_2_1()));
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (ruleCall.getRule() == grammarAccess.getABSRule())
			return getABSToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getAlwaysOperatorRule())
			return getAlwaysOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getAndOperatorRule())
			return getAndOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getCOLONRule())
			return getCOLONToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getCOMMARule())
			return getCOMMAToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getDIVIDERule())
			return getDIVIDEToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getEXPRule())
			return getEXPToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getEqualOperatorRule())
			return getEqualOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getEventuallyOperatorRule())
			return getEventuallyOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getFallOperatorRule())
			return getFallOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getHistoricallyOperatorRule())
			return getHistoricallyOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getIdentifierRule())
			return getIdentifierToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getIffOperatorRule())
			return getIffOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getImpliesOperatorRule())
			return getImpliesOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getLBRACKRule())
			return getLBRACKToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getLPARENRule())
			return getLPARENToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getMINUSRule())
			return getMINUSToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getNextOperatorRule())
			return getNextOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getOnceOperatorRule())
			return getOnceOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getOrOperatorRule())
			return getOrOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getPLUSRule())
			return getPLUSToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getPOWRule())
			return getPOWToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getPreviousOperatorRule())
			return getPreviousOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getRBRACKRule())
			return getRBRACKToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getRPARENRule())
			return getRPARENToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getRiseOperatorRule())
			return getRiseOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getSQRTRule())
			return getSQRTToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getTIMESRule())
			return getTIMESToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getUNITRule())
			return getUNITToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getXorOperatorRule())
			return getXorOperatorToken(semanticObject, ruleCall, node);
		else if (ruleCall.getRule() == grammarAccess.getComparisonOpRule())
			return getcomparisonOpToken(semanticObject, ruleCall, node);
		return "";
	}
	
	/**
	 * terminal ABS: 'abs' ;
	 */
	protected String getABSToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "abs";
	}
	
	/**
	 * fragment AlwaysOperator: 'always' | 'G' ;
	 */
	protected String getAlwaysOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "always";
	}
	
	/**
	 * fragment AndOperator: 'and' | '&' ;
	 */
	protected String getAndOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "and";
	}
	
	/**
	 * terminal COLON: ':' ;
	 */
	protected String getCOLONToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return ":";
	}
	
	/**
	 * terminal COMMA: ',' ;
	 */
	protected String getCOMMAToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return ",";
	}
	
	/**
	 * terminal DIVIDE: '/' ;
	 */
	protected String getDIVIDEToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "/";
	}
	
	/**
	 * terminal EXP: 'exp' ;
	 */
	protected String getEXPToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "exp";
	}
	
	/**
	 * fragment EqualOperator: '==' | '=';
	 */
	protected String getEqualOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "==";
	}
	
	/**
	 * fragment EventuallyOperator: 'eventually' | 'F' ;
	 */
	protected String getEventuallyOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "eventually";
	}
	
	/**
	 * fragment FallOperator: 'fall' ;
	 */
	protected String getFallOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "fall";
	}
	
	/**
	 * fragment HistoricallyOperator: 'historically' | 'H' ;
	 */
	protected String getHistoricallyOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "historically";
	}
	
	/**
	 * terminal Identifier
	 * 	: IdentifierStart IdentifierPart* ;
	 */
	protected String getIdentifierToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "";
	}
	
	/**
	 * fragment IffOperator: 'iff' | '<->' ;
	 */
	protected String getIffOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "iff";
	}
	
	/**
	 * fragment ImpliesOperator: 'implies' | '->' ;
	 */
	protected String getImpliesOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "implies";
	}
	
	/**
	 * terminal LBRACK: '[' ;
	 */
	protected String getLBRACKToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "[";
	}
	
	/**
	 * terminal LPAREN: '(' ;
	 */
	protected String getLPARENToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "(";
	}
	
	/**
	 * terminal MINUS: '-' ;
	 */
	protected String getMINUSToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "-";
	}
	
	/**
	 * fragment NextOperator: 'next' | 'X' ;
	 */
	protected String getNextOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "next";
	}
	
	/**
	 * fragment OnceOperator: 'once' | 'O' ;
	 */
	protected String getOnceOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "once";
	}
	
	/**
	 * fragment OrOperator: 'or' | '|';
	 */
	protected String getOrOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "or";
	}
	
	/**
	 * terminal PLUS: '+' ;
	 */
	protected String getPLUSToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "+";
	}
	
	/**
	 * terminal POW: 'pow' ;
	 */
	protected String getPOWToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "pow";
	}
	
	/**
	 * fragment PreviousOperator: 'prev' | 'Y' ;
	 */
	protected String getPreviousOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "prev";
	}
	
	/**
	 * terminal RBRACK: ']' ;
	 */
	protected String getRBRACKToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "]";
	}
	
	/**
	 * terminal RPAREN: ')' ;
	 */
	protected String getRPARENToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return ")";
	}
	
	/**
	 * fragment RiseOperator: 'rise' ;
	 */
	protected String getRiseOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "rise";
	}
	
	/**
	 * terminal SQRT: 'sqrt' ;
	 */
	protected String getSQRTToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "sqrt";
	}
	
	/**
	 * terminal TIMES: '*' ;
	 */
	protected String getTIMESToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "*";
	}
	
	/**
	 * terminal UNIT:
	 * 	SEC | MSEC | USEC | NSEC
	 * ;
	 */
	protected String getUNITToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "s";
	}
	
	/**
	 * fragment XorOperator: 'xor' ;
	 */
	protected String getXorOperatorToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "xor";
	}
	
	/**
	 * comparisonOp
	 * 	: LesserOrEqualOperator									| GreaterOrEqualOperator 								| LesserOperator										| GreaterOperator										| EqualOperator											| NotEqualOperator										;
	 */
	protected String getcomparisonOpToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "<=";
	}
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if (match_intervalTime_UNITTerminalRuleCall_0_1_q.equals(syntax))
				emit_intervalTime_UNITTerminalRuleCall_0_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_intervalTime_UNITTerminalRuleCall_1_1_q.equals(syntax))
				emit_intervalTime_UNITTerminalRuleCall_1_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_interval_COLONTerminalRuleCall_2_0_or_COMMATerminalRuleCall_2_1.equals(syntax))
				emit_interval_COLONTerminalRuleCall_2_0_or_COMMATerminalRuleCall_2_1(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     UNIT?
	 *
	 * This ambiguous syntax occurs at:
	 *     ilit=IntegerLiteral (ambiguity) (rule end)
	 *     lit=num_literal (ambiguity) (rule end)
	 *     rlit=RealLiteral (ambiguity) (rule end)
	 
	 * </pre>
	 */
	protected void emit_intervalTime_UNITTerminalRuleCall_0_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     UNIT?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) Identifier (ambiguity) (rule start)
	 
	 * </pre>
	 */
	protected void emit_intervalTime_UNITTerminalRuleCall_1_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * <pre>
	 * Ambiguous syntax:
	 *     COLON | COMMA
	 *
	 * This ambiguous syntax occurs at:
	 *     time1=intervalTime (ambiguity) time2=intervalTime
	 
	 * </pre>
	 */
	protected void emit_interval_COLONTerminalRuleCall_2_0_or_COMMATerminalRuleCall_2_1(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
